﻿Namespace Model
    Public Class Person
        Inherits ModelBase

        Public Sub New()
            ContactItems = New List(Of Contact)
        End Sub

        Public Sub New(firstName As String, lastName As String, firstContact As Contact)
            Me.New(EnuSalutation.Mister, firstName, lastName, Nothing, Nothing, New List(Of Contact) From {firstContact})
        End Sub

        Public Sub New(salutation As EnuSalutation, firstName As String, lastName As String, image As String, birthday As Date?, contacts As List(Of Contact))
            Me.Salutation = salutation
            Me.FirstName = firstName : Me.LastName = lastName
            Me.Image = image : Me.Birthday = birthday
            ContactItems = New List(Of Contact)
        End Sub


        Public Property Salutation As EnuSalutation = 0
        Public Property FirstName As String
        Public Property LastName As String

        Public ReadOnly Property FullName As String
            Get
                Return $"{FirstName} {LastName}"
            End Get
        End Property
        Public Property Image As String
        Public Property Birthday As Date?
        Public Property ContactItems As List(Of Contact)
        Public Property Notes As String
        Public Property IsFavorite As Boolean

        Public Property Group As String = "Ungrouped"

        Public Overrides Function ToString() As String
            Return $"{FirstName} {LastName}"
        End Function
    End Class

    Public Enum EnuSalutation
        Mister = 0
        Miss = 1
    End Enum

End Namespace
